#include <windows.h>
#include <stdio.h>

int n;

HANDLE done[4];

// void hutchTask()
// {
//     int var = 12345678;
// 
//     for(unsigned int i = 0; i < 4000000000 / n; i++)
//     {
//         __asm
//         {
//             mov eax, var
//             mov ecx, var
//             mov edx, var
//         }
//     }
// }


void hutchTask()
{
    int var = 12345678;
        __asm
        {

            push esi
            mov esi, 4000000000
          lbl0:
            mov eax, var
            mov ecx, var
            mov edx, var
            sub esi, 1
            jnz lbl0
            pop esi

        }
}




unsigned long __stdcall threadRoutine(void *parameter)
{
    hutchTask();

    SetEvent(done[*(int*)parameter]);

    return 0;
}

int main()
{
    DWORD elapsedMilliseconds[4];

    for(int threads = 1; threads <= 4; threads++)
    {
        n = threads;

        for(int i = 0; i < n; i++)
        {
            done[i] = CreateEvent(0, FALSE, FALSE, 0);
        }

        HANDLE threadHandle[4];
        int parameter[4] = {0, 1, 2, 3};

        DWORD startTime = GetTickCount();

        for(int i = 0; i < n; i++)
        {
            threadHandle[i] = CreateThread(0, 0, threadRoutine, &parameter[i], 0, 0);
        }

        WaitForMultipleObjects(n, done, true, INFINITE);

        elapsedMilliseconds[n - 1] = GetTickCount() - startTime;

        for(int i = 0; i < n; i++)
        {
            CloseHandle(done[i]);
            CloseHandle(threadHandle[i]);
        }

        printf("Milliseconds for %d threads: %d, multi-thread speedup: %f\n", n, elapsedMilliseconds[n - 1], (float)elapsedMilliseconds[0] / elapsedMilliseconds[n - 1]);
    }
}